{
    Problema se poate rezolva destul de bine (punctaj maxim, nu depaseste
  limita de timp) prin metoda Branch & Bound, aplicabila datorita faptului
  ca exista 2*3*4*5*6*7*8=40320 configuratii posibile. Se folosesc trei
  structuri mari de date: prima este coada clasica, a doua pastreaza pentru
  fiecare configuratie numarul celei din care provine (0 daca nu a fost
  obtinuta, 9999=caz special pentru configuratia initiala); cea de-a treia
  structura pastreaza tipul mutarii prin care s-a ajuns la starea curenta
  (putea fi evitata, caz in care se implementau inversele mutarilor).
    Procesul incepe cu introducerea starii initiale in coada. Cit timp nu s-a
  ajuns la solutie, se genereaza succesorii elementului din capul cozii;
  cei care nu au fost generati anterior sunt introdusi in coada, iar
  primul element este scos (capul cozii avanseaza).
    In final, procedura TRACE gaseste secventa prin care s-a ajuns la solutie,
  o memoreaza intr-o stiva si o afseaza, in ordinea normala, in fisierul de
  iesire.
}

{$r+}
{$m 5000,0,655360}
type ar=array[0..1000]of word;
     ar2=array[0..1000]of byte;
     arr=array[0..41]of ^ar;
     arr2=array[0..41]of ^ar2;
     ar8=array[0..9]of byte;
var coada,tata:arr;
    tmut:arr2;
    fact:array[0..9]of longint;
    x,nrmut,na,nb,nc,i,j,k,l,m,n,start,ending,fin,n1:longint;
    target,st,ma,mb,mc:ar8;
    fi,fo:text;
    stk:array[1..1000]of word;

procedure init;
begin
  for i:=0 to 41 do
      begin
        new(coada[i]);
        fillchar(coada[i]^,sizeof(coada[i]^),0);
        new(tata[i]);
        fillchar(tata[i]^,sizeof(tata[i]^),0);
        new(tmut[i]);
        fillchar(tmut[i]^,sizeof(tmut[i]^),0);
      end;
  fact[8]:=1;
  for i:=7 downto 1 do
      fact[i]:=fact[i+1]*(8-i);
end;

procedure readdata;
begin
  assign(fi,'input.txt');
  reset(fi);
  for i:=1 to 8 do
      read(fi,target[i]);
  close(fi);
end;

procedure tr1(a:ar8;var x:longint); { din tablou in numar }
var i,j:longint;
begin
  x:=0;
  for i:=1 to 8 do
      begin
        x:=x+fact[i]*(a[i]-1);
        for j:=i+1 to 8 do
            if a[j]>a[i] then dec(a[j]);
      end;
  x:=x+1;
end;

procedure tr2(x:longint;var a:ar8); { din numar in tablou }
begin
  x:=x-1;
  for i:=1 to 8 do
      begin
        a[i]:=(x div fact[i])+1;
        x:=x mod fact[i];
      end;
  for i:=8 downto 1 do
      for j:=i+1 to 8 do
          if a[j]>=a[i] then inc(a[j]);
end;

procedure movea;
var i:longint;
begin
  for i:=1 to 8 do
      ma[8-i+1]:=st[i];
  tr1(ma,na);
  if tata[na div 1000]^[na mod 1000]=0 then
     begin
       tata[na div 1000]^[na mod 1000]:=n1;
       tmut[na div 1000]^[na mod 1000]:=1;
       inc(ending);
       coada[ending div 1000]^[ending mod 1000]:=na;
     end;
end;

procedure moveb;
begin
  mb[1]:=st[4];
  mb[2]:=st[1];
  mb[3]:=st[2];
  mb[4]:=st[3];
  mb[5]:=st[6];
  mb[6]:=st[7];
  mb[7]:=st[8];
  mb[8]:=st[5];
  tr1(mb,nb);
  if tata[nb div 1000]^[nb mod 1000]=0 then
     begin
       tata[nb div 1000]^[nb mod 1000]:=n1;
       tmut[nb div 1000]^[nb mod 1000]:=2;
       inc(ending);
       coada[ending div 1000]^[ending mod 1000]:=nb;
     end;
end;

procedure movec;
begin
  mc[1]:=st[1];
  mc[2]:=st[7];
  mc[3]:=st[2];
  mc[4]:=st[4];
  mc[5]:=st[5];
  mc[6]:=st[3];
  mc[7]:=st[6];
  mc[8]:=st[8];
  tr1(mc,nc);
  if tata[nc div 1000]^[nc mod 1000]=0 then
     begin
       tata[nc div 1000]^[nc mod 1000]:=n1;
       tmut[nc div 1000]^[nc mod 1000]:=3;
       inc(ending);
       coada[ending div 1000]^[ending mod 1000]:=nc;
     end;
end;

procedure trace;
begin
  x:=coada[start div 1000]^[start mod 1000];
  nrmut:=0;
  while tata[x div 1000]^[x mod 1000]<>9999 do
    begin
      inc(nrmut);
      stk[nrmut]:=tmut[x div 1000]^[x mod 1000];
      x:=tata[x div 1000]^[x mod 1000];
    end;
  assign(fo,'output.txt');
  rewrite(fo);
  writeln(fo,nrmut);
  for i:=nrmut downto 1 do
      begin
        case stk[i] of
          1:writeln(fo,'A');
          2:writeln(fo,'B');
          3:writeln(fo,'C');
        end;
      end;
  close(fo);
end;

procedure solve;
begin
  start:=1;
  ending:=1;
  tata[0]^[1]:=9999; {  ATENTIE !!!!!  }
  tr1(target,fin);
  coada[0]^[1]:=1; {  1 div 1000  ,  1 mod 1000  }
  while coada[start div 1000]^[start mod 1000]<>fin do
    begin
      n1:=coada[start div 1000]^[start mod 1000];
      tr2(n1,st);
      movea;
      moveb;
      movec;
      inc(start);
      if coada[start div 1000]^[start mod 1000]=fin then
         begin
           trace;
           halt;
         end;
    end;
  
end;

begin
  init;
  readdata;
  solve;
end.