{Solution for IOI6 day 2 problem 2 by Brian Jones (c) 1994}
{$I-}
PROGRAM Problem3;

TYPE
  circle = ARRAY [1..6] OF byte;
  psol = ^solution;
  solution = RECORD
    sector : circle;
    size : byte;
    next : psol;
  END;

VAR inputf, outputf : text;
    m,n,k,i : byte;
    sector, best : circle;
    largest  : byte;
    p, q, solutions : psol;

PROCEDURE AddSolution (sec: circle; sz : byte);
  VAR p : psol;
  BEGIN
    p := solutions;
    WHILE p^.next <> NIL DO
      p := p^.next;
    new (p^.next);
    p := p^.next;
    p^.sector := sec;
    p^.size := sz;
    p^.next := NIL;
  END;


FUNCTION canMake (h : byte; sector :circle) : boolean;
  VAR i,j,l : byte;
      cando : boolean;

  BEGIN
    cando := false;
    FOR i := 1 TO n DO BEGIN
      l := sector [i];
      IF i < n
        THEN j := i+1
        ELSE j := 1;
      WHILE (l < h) AND (sector [j] <> 0) AND (j<>i) DO BEGIN
        inc (l, sector [j]);
        inc (j);
        IF j > n
          THEN j := j MOD n
      END;
      cando := cando OR (l = h);
    END;
    canMake := cando;
  END;

PROCEDURE add (sec, no, high : byte; sector : circle);
  VAR i,j : byte;
      empty : SET OF 1..6;
  BEGIN
    empty := [];
    sector [sec] := no;
    inc (high);
    WHILE canMake (high, sector) DO
      inc (high);
    FOR i := 1 TO n DO
      IF sector [i] = 0
        THEN empty := empty + [i];
    IF empty <> []
      THEN FOR i := 1 TO n DO BEGIN
        IF (NOT (i IN empty)) AND (( (i + 1) MOD n) IN empty) AND
           ( (high - sector [i]) >= k)
          THEN add ((i+1) MOD n, high - sector [i], high, sector);
        IF (NOT (i IN empty)) AND (( (i + n - 2) MOD n + 1) IN empty) AND
           ( (high - sector [i]) >= k)
          THEN add ((i+n-2) MOD n + 1, high - sector [i], high, sector);
        IF (i IN empty)
          THEN add (i,high,high,sector);
        END
      ELSE IF high >= largest
        THEN BEGIN
          largest := high;
          Addsolution (sector, high-1);
        END;
  END;

PROCEDURE out (sec : circle);
  VAR s,i : byte;
  BEGIN
    s := 1;
    FOR i := 1 TO n DO
      IF sec [i] < sec [s]
        THEN s := i;
    write (outputf, sec[s]);
    IF s < n
      THEN i := s + 1
      ELSE i := 1;
    REPEAT
      write (outputf, ' ', sec[i]);
      inc (i);
      IF i > n
        THEN i := 1;
    UNTIL i = s;
  END;

FUNCTION equal (a,b : circle) : boolean;
  VAR i,s: byte; overall,yes : boolean;
  BEGIN
    overall := false;
    FOR s := 1 TO n DO BEGIN
      yes := true;
      FOR i := 1 TO n DO
        yes := yes AND (a[i] = b[(i+s) MOD n+1]);
      overall := overall OR yes;
    END;
    equal := overall;
  END;



BEGIN
  assign (inputf, 'input.txt');
  reset (inputf);
  assign (outputf, 'output.txt');
  rewrite (outputf);
  readln (inputf, n);
  readln (inputf, m);
  readln (inputf, k);
  FOR i := 1 TO 6 DO
    sector [i] := 0;
  largest := m;
  new (p);
  p^.next := NIL;
  p^.size := 0;
  solutions := p;
  FOR i := k TO m DO
    add (1,i,i,sector);
  WriteLn(outputf, largest-1);
  p := solutions;
  REPEAT
    p := p^.next;
    q := p;
    REPEAT
      q := q^.next;
      IF equal (q^.sector, p^.sector)
        THEN q^.size := 0;
    UNTIL q^.next = NIL
  UNTIL p^.next^.next = NIL;
  p := solutions;
  REPEAT
    p := p^.next;
    IF (p <> NIL) AND (p^.size = largest-1)
      THEN BEGIN
        out (p^.sector);
        writeln (outputf);
      END;
  UNTIL p = NIL;
  p := solutions^.next;
  REPEAT
    dispose (solutions);
    solutions := p;
    IF p <> NIL
      THEN p := p^.next;
  UNTIL p = NIL;
  close (inputf);
  close (outputf);
END.

