/*
**		Clocks.cpp by CDaly (5.24AM 15-7-94)
**
**		Sample solution to IOI6 prob 1 day 2
*/
#include <fstream.h>

const int FALSE = 0;
const int TRUE = !FALSE;

int clock[9];	  // Initial values of the clocks go here

// All possible moves
int moves[9][9] = { {1, 1, 0, 1, 1, 0, 0, 0, 0 },
						  {1, 1, 1, 0, 0, 0, 0, 0, 0 },
						  {0, 1, 1, 0, 1, 1, 0, 0, 0 },
						  {1, 0, 0, 1, 0, 0, 1, 0, 0 },
						  {0, 1, 0, 1, 1, 1, 0, 1, 0 },
						  {0, 0, 1, 0, 0, 1, 0, 0, 1 },
						  {0, 0, 0, 1, 1, 0, 1, 1, 0 },
						  {0, 0, 0, 0, 0, 0, 1, 1, 1 },
						  {0, 0, 0, 0, 1, 1, 0, 1, 1 },
						};

void get_input()
{
	ifstream in("input.txt");

	for(int i = 0; i < 9; i++)
		in >> clock[i];
}

void make(int move)
{
	// Move all the hands according to the move array
	for(int i = 0; i < 9; i++)
		clock[i] += moves[move][i];
}

void undo(int move)
{
	// Put back the hands
	for(int i = 0; i < 9; i++)
		clock[i] -= moves[move][i];
}

// are all the clocks at twelve
int at_twelve()
{
	for (int i = 0 ;i < 9; i++)
		if (clock[i] % 4 != 0)
			return FALSE;

	return TRUE;
}

int path[27];
int num_moves = 0;
int min = 28;

void search(int m)
{
	if (num_moves < min)	// No point going on if can't make a amin
		if (at_twelve())
			{
			// All clocks at twelve (we're finished)
			min = num_moves;

			for(int i = 0; i < num_moves; i++)
				cout << path[i] + 1 << ' ';
			cout << endl;
			}
		else
			for(int move = m + 1; move < 9; move++)
					{
					// try each move three times
					for(int i = 0 ;i < 3; i++)
						{
						path[num_moves++] = move;	// Remember the path
						make(move);
						search(move);
						}
					// Undo the three moves
					num_moves -= 3;
					undo(move);
					undo(move);
					undo(move);
					}
}

void main()
{
	get_input();

	search(-1);
}
