// IOI 1994 castle problem by Henrik Edstroem

#include <fstream.h>

int nHeight, nWidth;
int nWalls[50][50];
int nRoom[50][50];
int nRoomSizes[50*50];
int nRooms = 0;
int nBestSize = 0;

int nDY[9] = {0, 0, -1, 0, 0, 0, 0, 0, 1};
int nDX[9] = {0, -1, 0, 0, 1, 0, 0, 0, 0};
char chDir[9] = {0, 'W', 'N', 0, 'E', 0, 0, 0, 'S'};

void MakeRoom(int y, int x, int n)
{
	if (nRoom[y][x] != 0)
		return;
	if (++nRoomSizes[n] > nBestSize)
		nBestSize = nRoomSizes[n];
	nRoom[y][x] = n;
	for (int dir = 1; dir <= 8; dir <<= 1)
		if ((nWalls[y][x] & dir) == 0)
			MakeRoom(y + nDY[dir], x + nDX[dir], n);
}                              

void KnockDownWall(int y, int x, int dir)
{
	static int nBestTotalSize = 0;
	int nTotalSize = nRoomSizes[nRoom[y][x]] + nRoomSizes[nRoom[y + nDY[dir]][x + nDX[dir]]];
	if (nTotalSize <= nBestTotalSize)
		return;
	ofstream("output.txt") << nRooms << endl << nBestSize << endl << y << " " << x << " " << chDir[dir] << endl;
	nBestTotalSize = nTotalSize;
}

void main()
{
	ifstream in("input.txt");
	in >> nHeight >> nWidth;        
	for (int y = 1; y <= nHeight; y++)
		for (int x = 1; x <= nWidth; x++)
			in >> nWalls[y][x];
      
	for (y = 1; y <= nHeight; y++)
		for (int x = 1; x <= nWidth; x++)
			if (nRoom[y][x] == 0)
				MakeRoom(y, x, ++nRooms);

	for (y = 1; y <= nHeight; y++)
		for (int x = 1; x <= nWidth; x++)
			for (int dir = 1; dir <= 8; dir <<= 1)
				if ((nWalls[y][x] & dir) != 0)
					KnockDownWall(y, x, dir);
}
