{
   Solution for problem 3 day 1.

   By Fredrik Huss of Sweden in 1994.

   ========================================================================
}

{$M 16384,64000,655360}

Type
   Arr = Array[0..49999] of Boolean;
Const
   Divisor : Array[0..4] of Longint = (10000,1000,100,10,1);
   Bits : Array[0..9] of Word = (1,2,4,8,16,32,64,128,256,512);
Var
   Prime : ^Arr;
   NextNumber : Array[0..9999] of Word;
   Sum,nPrimes : Integer;
   FirstNumber,i,j,k : Longint;
   VerticalPrimeStart : Array[0..5,0..5] of Word;
   Kvadrat : Array[0..4] of Longint;
   w : Word;
   f : Text;

Function DigitSum(i : Longint) : Integer;
Var s : String[5];
Begin
   Str(i,s);
   If Length(s)=5 then
      DigitSum:=Integer(s[1])+Integer(s[2])+Integer(s[3])+Integer(s[4])+
         Integer(s[5])-5*48
   else
      DigitSum:=-1;
End;

Procedure TryLine(n : Integer); Forward;

Procedure GenPrime(p : Word; n,nn : Integer);
{
   Input: p  : The first part of the prime number on the current row
          n  : The length of the number above
          nn : The current row number-1
}
Var a,i,vp : Word;
Begin
   vp:=VerticalPrimeStart[nn,n];

   {
   Calculate all possible numbers for the next digit.
   }
   a:=NextNumber[vp] and NextNumber[p];

   vp:=vp*10;
   If n<4 then Begin
      {
      Generate the next number on the row
      }
      p:=p*10;
      For i:=0 to 9 do
         If (a and Bits[i])>0 then Begin
            VerticalPrimeStart[nn+1,n]:=vp+i;
            GenPrime(p+i,n+1,nn);
         End;
   End else Begin
      {
      Recurse to the next row
      }
      For i:=0 to 9 do
         If (a and Bits[i])>0 then Begin
            VerticalPrimeStart[nn+1,n]:=vp+i;
            Kvadrat[nn]:=Longint(p)*10+Longint(i);
            TryLine(nn+1);
         End;
   End;
End;

Procedure TryLine(n : Integer);
Var i : Integer; j,k : Longint; s : String[5];
Begin
   If n<5 then
      {
      Generate the next row
      }
      GenPrime(0,0,n)
   else Begin
      {
      Done! Check the diagonals.
      }
      j:=0; k:=0;
      For i:=0 to 4 do Begin
         j:=j*10+(Kvadrat[i] DIV Divisor[i]) MOD 10;
         k:=k*10+(Kvadrat[4-i] DIV Divisor[i]) MOD 10;
      End;
      If Prime^[j SHR 1] and Prime^[k SHR 1] then Begin
         {
         We have a solution!
         }
         For i:=0 to 4 do
            Writeln(f,Kvadrat[i]);
      End;
   End;
End;

Begin
   Assign(f,'INPUT.TXT'); Reset(f);
   Readln(f,Sum);
   Readln(f,FirstNumber);
   Close(f);

   GetMem(Prime,Sizeof(Prime^));
   FillChar(Prime^,Sizeof(Prime^),1);
   FillChar(NextNumber,Sizeof(NextNumber),0);
   FillChar(VerticalPrimeStart,Sizeof(VerticalPrimeStart),0);

   {
   Calculate primes... (only odd numbers are stored)
   }
   i:=3;
   Repeat
      If Prime^[i SHR 1] then Begin
         j:=i*i;
         While j<100000 do Begin
            Prime^[j SHR 1]:=False;
            Inc(j,i+i);
         End;
      End;
      Inc(i,2);
   Until i>320;

   {
   Check the digit sum.
   }
   For i:=0 to 49999 do
      If Prime^[i] then
         If DigitSum(i+i+1)<>Sum then
            Prime^[i]:=False
         else Inc(nPrimes);

   {
   Find all digits possible to add to the beginning of a prime.
   }
   For i:=1 to 4 do
      For j:=5000 to 49999 do
         If Prime^[j] then Begin
            k:=(j+j+1) DIV Divisor[i-1];
            w:=Bits[((j+j+1) DIV Divisor[i]) MOD 10];
            NextNumber[k]:=NextNumber[k] or w;
         End;
   NextNumber[0]:=1023-1; { A prime can begin with the numbers 1..9 }

   VerticalPrimeStart[1,0]:=FirstNumber;

   Assign(f,'OUTPUT.TXT'); Rewrite(f);
   GenPrime(FirstNumber,1,0);
   Close(f);
End.
