#ifdef __TURBOC__

/* PC stuff */

#include <bios.h>
#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>

#define FALSE 0
#define TRUE  1

#define FG 15
#define BG 0
#define TXT_COL 14
#define CURS 12

#define TOP_MARG 16

#define K_UP     -0x48
#define K_DOWN   -0x50
#define K_LEFT   -0x4b
#define K_RIGHT  -0x4d
#define K_SUP    -0x98
#define K_SDOWN  -0xa0
#define K_SLEFT  -0x9b
#define K_SRIGHT -0x9d


#define BLUE    1
#define GREEN   2
#define CYAN    3
#define RED     4
#define LILA   13
#define YELLOW 14

void colour(int c)
{
  setcolor (c);
}

//void line(int x1,int y1,int x2,int y2)

void clear(void)
{
  cleardevice ();
}

void text(char *t, int x, int y)
{
  bar(x<<3, y<<3, ((x+strlen(t))<<3)-1, ((y+1)<<3)-1);
  setcolor(TXT_COL);
  outtextxy (x<<3, y<<3, t);
}

void clear_status(void)
{
  bar(0,0,640,8);
}


int initstuff(void)
{
  int gdriver = VGA, gmode = VGAHI;

  initgraph (&gdriver, &gmode, "");
  settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
  setfillstyle (SOLID_FILL, BG);
  return 1;
}

void closestuff(void)
{
  closegraph ();
}

/* End of PC stuff */

#endif
#define LOWLEFTX 100
#define LOWLEFTY 440

void vLine (int iX1, int iY1, int iX2, int iY2)
{
  line ( LOWLEFTX + iX1*4, LOWLEFTY - iY1*4,
	 LOWLEFTX + iX2*4, LOWLEFTY - iY2*4 );
}

void vCross (int iX, int iY, int iColor)
{
  iX *= 4;
  iY *= -4;
  setcolor (LILA);
  line ( LOWLEFTX + iX-2, LOWLEFTY + iY-2,
	 LOWLEFTX + iX+2, LOWLEFTY + iY+2 );
  line ( LOWLEFTX + iX-2, LOWLEFTY + iY+2,
	 LOWLEFTX + iX+2, LOWLEFTY + iY-2 );
  setcolor (iColor);
}

void vDrawUnit (int iX, int iY)
{
  int i;

  for (i=1; i<4; i++)
    line ( LOWLEFTX + iX*4+1, LOWLEFTY - (iY*4+i),
	   LOWLEFTX + iX*4+3, LOWLEFTY - (iY*4+i)  );
}

void vDrawSquare (int iX, int iY)
{
  int i,j;

  for (i=0; i<5; i++)
    for (j=0; j<5; j++)
      vDrawUnit (iX+i, iY+j);
}


void vDrawFirst ()
{
   int i;

   for (i=0; i<=25; i+=5)
   {
     vLine ( -1,   0+i*4, 101,   0+i*4);
     vLine (  0+i*4,  -1,   0+i*4, 101);
   }
}



/*****
void doit()
{
  int i;
  colour(7);

  for (i=0; i<400; i+=5)
    line (0,i,i,400);
}
*******/



int fDrawHouses (char szName[])
{
   int i, iNum, iX, iY;
   FILE *fh;

   fh = fopen (szName, "rt");
   if (fh)
   {
      fscanf (fh, "%d", &iNum);
      for (i=0; i<iNum; i++)
      {
	 fscanf (fh, "%d %d", &iX, &iY);
	 vDrawSquare (iX, iY);
      }
      fclose (fh);
   }
   else
     return FALSE;

   return TRUE;
}

#define SQR(x) (x)*(x)


double adDrawPath (char szName[], int iColor)
{
   FILE *fh;
   int iX, iY, iOldX, iOldY;
   double ad=0.0;

   fh = fopen (szName, "rt");
   if (fh)
   {
      fscanf (fh, "%d %d", &iOldX, &iOldY);
      while (fscanf (fh, "%d %d", &iX, &iY)!=EOF)
      {
	 ad += sqrt ( SQR(iX-iOldX) + SQR(iY-iOldY) );
	 setcolor (iColor);
	 vLine (iOldX, iOldY, iX, iY);
	 if (iOldX || iOldY)
	   vCross (iOldX, iOldY, iColor);
	 iOldX = iX;
	 iOldY = iY;
      }
      fclose (fh);
   }
   else
     return 0.0;
   return ad;
}

void vDrawPaths (char szName[], int iColor)
{
   FILE *fh;
   int iX, iY, iOldX, iOldY;
   int iChar;
   static unsigned char szBuf[100];

   fh = fopen (szName, "rt");
   if (fh)
   {
      while ( (iChar=fgetc (fh)) != EOF )
      {
	 if (iChar!=254)
	   ungetc (iChar, fh);
	 else
	 {
	   fgets (szBuf, 100,fh);
	   fscanf (fh, "%d %d", &iOldX, &iOldY);
	 }

	 fscanf (fh, "%d %d", &iX, &iY);
	 setcolor (iColor);
	 vLine (iOldX, iOldY, iX, iY);
	 if (iOldX || iOldY)
	   vCross (iOldX, iOldY, iColor);
	 iOldX = iX;
	 iOldY = iY;
      }

      fclose (fh);
   }
}

void main(int argc, char *argv[])
{
  int i;
  double ad;

  if(initstuff())
  {
    setcolor (2);
    vDrawFirst();
    setcolor (3);
    fDrawHouses ("input.txt");
    for (i=1; i<argc; i++)
    {
      if (argv[i][0]=='-')
	vDrawPaths (argv[i]+1, RED);
      else
	adDrawPath (argv[i], RED);
    }
    ad = adDrawPath ("output.txt", YELLOW);

    getch();
    closestuff();
  }
  printf ("Length of output.txt = %6.6f\n", ad);
}
