#include <fstream.h>

const int NUM_CITIES = 7;

int to_visit[NUM_CITIES][NUM_CITIES];
int distance[NUM_CITIES][NUM_CITIES];
int trips_from[NUM_CITIES];

int n, num_trips, total_distance;

int index(char c)
{
	return c - 'A';
}

void get_input()
{
	ifstream in("input.txt");
	char city1, city2;

	in >> n;

	num_trips = n;

	for (int i = 0; i < n; i++)
		{
		in >> city1 >> city2;

		trips_from[index(city1)]++;
		to_visit[index(city1)][index(city2)]++;	// Another trip between these
		}														// cities

	in.close();;

	in.open("distance.txt");

	for(i = 0; i < NUM_CITIES; i++)
		for(int j = 0 ;j < NUM_CITIES; j++)
			in >> distance[i][j];
}

int min = 10000;
char path[40];
char max_path[40];
int num_flights;
int max_flights;

void visit(int city)
{
	if (total_distance + distance[city][0] > min)
  		return;	 // More than min, give up.

	path[num_flights++] = city;
	if (num_trips == 0 || (num_trips == 1 && to_visit[city][0]))
		{
		// Done all the transporting
		if (total_distance + distance[city][0] < min)
			{
			// New best
			min = total_distance + distance[city][0];
			for (int i = 0 ;i < num_flights; i++)
				max_path[i] = path[i];
			max_flights = num_flights;
			}
		}
	else
		{
		// Carry on searching
		// Is there something to go from this city
		if (trips_from[city])
			{
			for(int next = 0; next < NUM_CITIES; next++)
				if (to_visit[city][next])
					{
					trips_from[city]--;
					to_visit[city][next]--;
					total_distance += distance[city][next];
					num_trips--;
					visit(next);
					num_trips++;
					total_distance -= distance[city][next];
					to_visit[city][next]++;
					trips_from[city]++;
					}
			}
		else	// find a city which requires transport
			for(int next = 0; next < NUM_CITIES; next++)
				if (trips_from[next])
					{
					total_distance += distance[city][next];
					visit(next);
					total_distance -= distance[city][next];
					}
		}

	num_flights--;
}

void main()
{
	get_input();

	visit(0);

	cout << min << endl;
	for(int i = 0 ;i < max_flights; i++)
		cout << (char)(max_path[i] + 'A') << ' ';

	cout << 'A' << endl;
}



		
