// IOI transportation problem by Henrik Edstroem

#include "fstream.h"

enum BOOL {FALSE = 0, TRUE = 1};

#define HOME_TOWN       'A'

// Order data
int nOrders;
char pOrderFrom[100];
char pOrderTo[100];

// Permutation data
BOOL pOrderTaken[100];
int pOrderList[100];
int nBestSoFar = 0x7FFF;
int nCargoFlying = 0;

// Return the distance between two cities
int Distance(char nFrom, char nTo)
{
	static int arrDistances[7][7] =
	{
		{00, 56, 43, 71, 35, 41, 36},
		{56, 00, 54, 58, 36, 79, 31},
		{43, 54, 00, 30, 20, 31, 58},
		{71, 58, 30, 00, 38, 59, 75},
		{35, 36, 20, 38, 00, 44, 40},
		{41, 79, 31, 59, 44, 00, 72},
		{36, 31, 58, 75, 40, 72, 00}
	};
	return arrDistances[nFrom - 'A'][nTo - 'A'];
}

// Order list complete
void ListComplete(int nNoCargoFlying)
{
	if (nNoCargoFlying >=nBestSoFar)
		return;
	nBestSoFar = nNoCargoFlying;
	ofstream out("OUTPUT.TXT");
	out << nNoCargoFlying + nCargoFlying << endl << HOME_TOWN;
	for (int i = 0; i < nOrders; i++)
	{
		if (pOrderFrom[pOrderList[i]] != (i > 0 ? pOrderTo[pOrderList[i - 1]] : HOME_TOWN))
			out << " " << pOrderFrom[pOrderList[i]];
		out << " " << pOrderTo[pOrderList[i]];
	}
	if (pOrderTo[pOrderList[nOrders - 1]] != HOME_TOWN)
		out << " " << HOME_TOWN;
}

// Make one order and recurse to make next
void MakeOrder(int nOrdersInList, int nNoCargoFlying, char nFrom)
{
	if (nNoCargoFlying < nBestSoFar)
		if (nOrdersInList == nOrders)
			ListComplete(nNoCargoFlying + Distance(pOrderTo[pOrderList[nOrders - 1]], HOME_TOWN));
		else
			for (int i = 0; i < nOrders; i++)
				if (pOrderTaken[i] == FALSE)
				{
					pOrderList[nOrdersInList] = i;
					pOrderTaken[i] = TRUE;
					MakeOrder(nOrdersInList + 1, nNoCargoFlying + Distance(nFrom, pOrderFrom[i]), pOrderTo[i]);
					pOrderTaken[i] = FALSE;
				}
}

// Main
void main()
{
	// Init data
	ifstream in("INPUT.TXT");
	in >> nOrders;
	for (int i = 0; i < nOrders; i++)
	{
		in >> pOrderFrom[i] >> pOrderTo[i];
		nCargoFlying += Distance(pOrderFrom[i], pOrderTo[i]);
	}

	// Start permutating
	MakeOrder(0, 0, HOME_TOWN);
}
