@ECHO OFF

REM Parametrul %1 este numele programului care va fi evaluat
REM Parametrul %2 este numarul testului care va fi folosit pentru evaluare

REM Se initializeaza ecranul
  MODE CON LINES=50

REM Se valideaza parametrul %1 (numele programului)
  IF "%1"=="/?" GOTO Help
  IF "%1"=="" GOTO NoUser
  IF NOT EXIST %1 GOTO NoUser


REM Se initializeaza numele problemei
  SET PROB=mars

REM Se porneste evaluarea
  CLS
  ECHO PROBLEM NAME: %PROB%
  ECHO.
  ECHO Running "%1" on test "%2"...

REM Se initializeaza numele fisierelor folosite la evaluare 
  SET IN_1=%PROB%.dat
  SET OUT_1=%PROB%.out
  SET OK_1=%PROB%.ok

  SET LOAD_1=test\%PROB%%2.dat
  SET SAVE_1=test\%PROB%%2.new
  SET SOL_1=test\%PROB%%2.sol

REM Se copiaza datele de intrare
  COPY /Y %LOAD_1% %IN_1% > nul 

REM Se ruleaza si se cronometreaza programul
  timerx.exe %1

REM Se copiaza fisierul cu solutia comisiei
  COPY /Y %SOL_1% %OK_1% > nul

REM Se evalueaza solutia data de concurent
  ECHO.
  ECHO Evaluating output...
  eval.exe

REM Se salveaza datele de iesire ale concurentului
  COPY /Y %OUT_1% %SAVE_1% > nul

REM Se asteapta apasarea unei taste
  ECHO.
  ECHO.
  PAUSE

REM Se termina executia bat-ului cu succes
  GOTO End

:NoFile
GOTO End

:NoUser
  ECHO Missing contestant program named "%1"

:Help
  ECHO Syntax: TEST.BAT id.exe test (.exe is *not* optional)
GOTO End

:End