{$I+,Q+,R+,S+}
const
  dmax = 50+1;
  nmax = 1000;
  finame = 'mars.dat';
  foname = 'mars.flu';
var
  fi, fo: text;
  n, scv, x, y, i, j, k, kk: longint;
  a, u: array[0..dmax] of array[0..dmax] of longint;

  sursa, dest1, dest2, flow, pietre: longint;
  c, w, f: array[0..nmax] of array[0..nmax] of longint;
  yy, xx, t, d: array[0..nmax] of longint;
  ok: boolean;

procedure readdata;
begin
  assign(fi, finame);
  reset(fi);
  read(fi, scv, x, y);
  for i := 1 to y do
    for j := 1 to x do
      read(fi, a[i][j]);
  for i := 1 to y+1 do
    begin a[i][x+1] := 1; a[i][0] := 1; end;
  for j := 1 to x+1 do
    begin a[y+1][j] := 1; a[0][j] := 1; end;
  close(fi);
end;

procedure df1;
begin
  if a[i][j] = 1 then exit;
  if u[i][j] >= 1 then exit;

  inc(u[i][j], 1);
  inc(i); df1; dec(i);
  inc(j); df1; dec(j);
end;

procedure df2;
begin
  if a[i][j] = 1 then exit;
  if u[i][j] >= 2 then exit;

  inc(u[i][j], 2);
  dec(i); df2; inc(i);
  dec(j); df2; inc(j);
end;

procedure init1;
begin
  i := 1; j := 1; df1;
  i := y; j := x; df2;

  n := 0;
  for i := 1 to y do
    for j := 1 to x do
      if a[i][j] = 2 then
        if u[i][j] = 3 then
        begin
          inc(n); yy[n] := i; xx[n] := j;
       end;
end;

function prim(i: longint): longint;
begin prim := 2*i-1; end;

function secund(i: longint): longint;
begin secund := 2*i; end;

procedure init2;
begin
  fillchar(w, sizeof(w), 0);
  fillchar(c, sizeof(c), 0);

  for k := 1 to n do
  begin
    i := yy[k]; j := xx[k];
    fillchar(u, sizeof(u), 0);
    df1; u[i][j] := 0;

    for kk := 1 to n do
      if u[ yy[kk] ][ xx[kk] ] = 1 then
      begin
        w[secund(k)][prim(kk)] := 0;
        c[secund(k)][prim(kk)] := scv;
      end;
  end;

  sursa := 0;
  dest1 := prim(n+1);
  dest2 := secund(n+1);

  w[sursa][dest1] := 0;
  c[sursa][dest1] := scv;

  w[dest1][dest2] := 0;
  c[dest1][dest2] := scv;

  for k := 1 to n do
  begin
    w[sursa][prim(k)] := 0;
    c[sursa][prim(k)] := scv;

    w[prim(k)][secund(k)] := 1;
    w[secund(k)][prim(k)] := -1;
    c[prim(k)][secund(k)] := 1;

    w[secund(k)][dest1] := 0;
    c[secund(k)][dest1] := scv;
  end;
end;

procedure findpath;
begin
  fillchar(d, sizeof(d), 0);
  fillchar(t, sizeof(t), 0);
  t[dest2] := dest1; t[dest1] := sursa;
  repeat
    ok := true;
    for i := sursa to dest2 do
      for j := sursa to dest2 do
        if c[i][j] - f[i][j] > 0 then
          if d[i] + w[i][j] > d[j] then
          begin
            ok := false;
            d[j] := d[i] + w[i][j];
            t[j] := i;
          end;
  until ok;
end;

procedure growflow;
begin
  i := dest2;
  while i <> sursa do
  begin
    inc(f[ t[i] ][ i ]);
    dec(f[ i ][ t[i] ]);
    i := t[i];
  end;
end;

procedure solvprob;
{ nodurile sunt numerotate de la 0 la dest2 }
{ pur si simplu gaseste fluxul maxim de cost maxim intr-un graf oarecare }
begin
  fillchar(f, sizeof(f), 0);
  pietre := 0;
  for flow := 1 to scv do
  begin
    findpath;
    writeln(d[dest2]);
    inc(pietre, d[dest2]);
    growflow;
  end;
end;

procedure writesol;
begin
  writeln('S-au adunat ', pietre, ' pietre.');
  writeln('Nu ma mai obosesc sa afisez in fisier.');
  writeln('O sa se busheasca evaluatorul :)');
end;

begin
  readdata;
  init1;
  init2;
  writeln('Graful are noduri de la 0 la ', dest2);
  solvprob;
  writesol;
end.
